#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire400four4xi.py">
#<abstract4xi abstract = "fires to direction four and to distance 400"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire400four4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>

       
# -------------------------------------------------------------------------------------------------
# SHOT2FOUR - COORDINATE SIGNS OF SHOOT2FOUR4XI: (X + ,Y - ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2four4004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False


shot2four4004xi = {
                1:'101x-378y78z',
                2:'105x-153y353z',
                3:'105x-72y379z',
                4:'106x-225y312z',
                5:'112x-68y377z',
                6:'115x-150y352z',
                7:'118x-64y376z',
                8:'119x-222y309z',
                9:'121x-373y74z',
                10:'125x-147y350z',
                11:'125x-59y375z',
                12:'131x-54y373z',
                13:'133x-218y307z',
                14:'135x-143y348z',
                15:'138x-48y372z',
                16:'141x-367y70z',
                17:'143x-42y370z',
                18:'145x-138y346z',
                19:'146x-214y304z',
                20:'147x-274y250z',
                21:'149x-35y369z',
                22:'154x-132y344z',
                23:'154x-28y367z',
                24:'158x-208y302z',
                25:'159x-21y366z',
                26:'160x-360y66z',
                27:'163x-268y247z',
                28:'164x-126y342z',
                29:'164x-13y364z',
                30:'168x-4y362z',
                31:'171x-202y299z',
                32:'173x-119y339z',
                33:'178x-262y243z',
                34:'179x-352y62z',
                35:'182x-112y337z',
                36:'183x-195y296z',
                37:'190x-104y335z',
                38:'193x-254y240z',
                39:'196x-187y294z',
                40:'197x-342y58z',
                41:'199x-95y333z',
                42:'206x-86y331z',
                43:'207x-178y291z',
                44:'207x-245y237z',
                45:'20x-388y93z',
                46:'214x-76y329z',
                47:'215x-332y54z',
                48:'219x-169y288z',
                49:'221x-66y326z',
                50:'222x-236y234z',
                51:'227x-55y324z',
                52:'230x-159y285z',
                53:'233x-320y50z',
                54:'233x-43y322z',
                55:'235x-225y231z',
                56:'238x-31y319z',
                57:'23x-18y398z',
                58:'240x-148y282z',
                59:'242x-19y317z',
                60:'246x-7y314z',
                61:'249x-214y227z',
                62:'250x-137y280z',
                63:'250x-308y46z',
                64:'259x-125y277z',
                65:'261x-202y224z',
                66:'266x-295y42z',
                67:'268x-112y274z',
                68:'273x-189y221z',
                69:'276x-99y271z',
                70:'27x-19y398z',
                71:'27x-76y391z',
                72:'281x-281y38z',
                73:'283x-85y268z',
                74:'285x-176y217z',
                75:'290x-70y265z',
                76:'296x-162y214z',
                77:'296x-266y34z',
                78:'296x-56y262z',
                79:'301x-40y259z',
                80:'305x-25y256z',
                81:'306x-147y211z',
                82:'309x-250y30z',
                83:'309x-9y253z',
                84:'315x-132y207z',
                85:'322x-234y26z',
                86:'32x-19y398z',
                87:'32x-78y390z',
                88:'334x-217y22z',
                89:'346x-199y18z',
                90:'356x-181y14z',
                91:'365x-162y10z',
                92:'36x-19y397z',
                93:'373x-143y6z',
                94:'380x-123y2z',
                95:'38x-80y389z',
                96:'404x-145y255z',
                97:'40x-387y90z',
                98:'41x-19y397z',
                99:'44x-81y389z',
                100:'46x-18y396z',
                101:'50x-17y396z',
                102:'50x-82y388z',
                103:'55x-16y395z',
                104:'57x-83y387z',
                105:'60x-14y395z',
                106:'61x-385y86z',
                107:'63x-83y386z',
                108:'64x-11y394z',
                109:'65x-159y361z',
                110:'69x-8y393z',
                111:'70x-82y384z',
                112:'73x-5y393z',
                113:'75x-158y359z',
                114:'77x-1y392z',
                115:'77x-81y383z',
                116:'81x-382y82z',
                117:'84x-80y382z',
                118:'85x-157y357z',
                119:'91x-78y381z',
                120:'95x-156y355z'}

#"
#"/>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire400four4xi" usage = "target function for charge4004xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire400four4xi(queue2four, consumer_channel2four, publisher_channel2four):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE400FOUR4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE400FOUR4XI -  QUEUE2FOUR: ", queue2four)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE400FOUR4XI -  CONSUMER_CHANNEL2FOUR: ", consumer_channel2four)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE400FOUR4XI -  PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE400FOUR4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2four.put(shot2four4004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE400FOUR4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE400FOUR4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE400FOUR4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2four8shot2four4004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2four8shot2four4004xi</nack2put4xi>" 
            
        publisher_channel2four.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE400FOUR4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE400FOUR4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE400FOUR4XI - RETURNING QUEUE OBJECT QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi())  
        # 
            
    return queue2four    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire400four4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
               